using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;
using System.ComponentModel;
using System.Drawing;


namespace CustomSettingsProvider
{
    [SettingsProviderAttribute(typeof(CustomSettingsProvider.Provider.MySqlSettingsProvider))]
    public class CustomSettings : ApplicationSettingsBase
    {
        #region Fields & Constructor

        public CustomSettings()
        {
            /// Die Informationen die dem Context-Element bergeben werden, sind hier nur zu Demonstrations-Zwecken
            /// direkt in der Klasse umgesetzt. Selbstverstndlich macht es Sinn, diese Auszulagern, 
            /// z.B. ber den LocalFileSettingsProvider
            this.Context.Add("SettingConnectionString", "User=root; Password=; Host=localhost; Port=3306; Database=DemoConfig;");
            this.Context.Add("SettingTable", "Config02");
            this.Context.Add("ClientID", "TestClient");
        }

        #endregion

        [ApplicationScopedSetting]
        [DefaultSettingValueAttribute("White")]
        [VersionAttribute("1.1.1.0")]
        public Color BackgroundColor
        {
            get { return (Color)this["BackgroundColor"]; }
            set { this["BackgroundColor"] = value; }
        }

        [UserScopedSetting]
        [DefaultSettingValueAttribute("White")]
        [VersionAttribute("1.2.3.4")]
        public string TestText
        {
            get { return this["TestText"].ToString(); }
            set { this["TestText"] = value; }
        }
    }
}